﻿using GalaSoft.MvvmLight;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Controls06
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            var items = new ObservableCollection<Content>();
            items.Add(new Content { Title = "Titolo 1", Author = "Daniele Bochicchio" });
            items.Add(new Content { Title = "Titolo 2", Author = "Daniele Bochicchio" });
            items.Add(new Content { Title = null, Author = "Daniele Bochicchio" });

            this.DataContext = new MainPageViewModel
            {
                Items = items,
                Text1 = "testo 1",
                Text2 = "testo 2"
            };

            // senza questa riga non andrà il binding
            var expression = MyText2.GetBindingExpression(TextBox.TextProperty);
            expression.UpdateSource();
        }

        private void MyText2_TextChanged(object sender, TextChangedEventArgs e)
        {
            // senza questa riga non andrà il binding
            var expression = MyText2.GetBindingExpression(TextBox.TextProperty);
            expression.UpdateSource();
        }
    }

    public class MainPageViewModel : ViewModelBase
    {
        private string _text1;
        public string Text1
        {
            get
            {
                return _text1;
            }
            set
            {
                Set(() => Text1, ref _text1, value);
            }
        }

        private string _text2;
        public string Text2
        {
            get
            {
                return _text2;
            }
            set
            {
                Set(() => Text2, ref _text2, value);
            }
        }

        public ObservableCollection<Content> Items { get; set; }
    }

    public class Content
    {
        public string Title { get; set; }
        public string Author { get; set; }
    }
}
